#ifndef _FORIJER_H_
#define _FORIJER_H_

#include <wx/wx.h>
#include <wx/spinctrl.h>
#include <vector>
#include "gnuplot.h"
#include "gpconsole.h"

/**
 * @short Application Main Window
 * @author Davor Cihlar,,, <davor@cihlar.biz>
 * @version 0.1
 */

class Forijerapp : public wxApp {
	public:
		bool OnInit();
		int OnExit();
		static wxString CollectExecOutput(const wxString &cmd);
		static wxString GetBCVersion();
		static wxString GetGPVersion();

	private:
		gnuplot *gp;
};

class ForijerFrame : public wxFrame {
	public:
		ForijerFrame(gnuplot *);
		void OnQuit(wxCommandEvent &);
		void OnAbout(wxCommandEvent &);
		void OnAboutBC(wxCommandEvent &);
		void OnAboutGnuplot(wxCommandEvent &);
		void OnGnuplotParametri(wxCommandEvent &);
		void OnShowGPConsole(wxCommandEvent &);
		void OnNew(wxCommandEvent &);
		void OnOpen(wxCommandEvent &);
		void OnSave(wxCommandEvent &);
		void OnSaveAs(wxCommandEvent &);
		void OnNacrtaj(wxCommandEvent &);
		void OnSpin(wxSpinEvent &);
		void ErrorBox(const wxString &msg, const wxString &title);
		bool ParseFnArray(std::vector<double> &list, const wxString &func, unsigned int size);
		bool LoadFormulas(const wxString &fname);
		bool SaveFormulas(const wxString &fname);
		
		bool ProzvaciPodatke();
		void Nacrtaj();

	private:
		enum {
			Menu_File_Quit = 1000,
			Menu_File_New,
			Menu_File_Open,
			Menu_File_Save,
			Menu_File_Save_As,
			Menu_Help_About,
			Menu_Help_About_bc,
			Menu_Help_About_gnuplot,
			Menu_Options_PojednostavniFormulu,
			Menu_Options_PrikazuFormulu,
			Menu_Options_PrikaziFormuluUKonzoli,
			Menu_Options_GnuplotParametri,
			Menu_Options_GnuplotConsole,
		};

		enum {
			id_Nacrtaj = 1,
			id_Spin,
		};

		wxTextCtrl *txtA0, *txtAn, *txtBn;
		wxCheckBox *chkRedrawAtChange;
		wxSpinCtrl *spnPrec;
		wxMenuItem *chkShowF, *chkShowFiC, *chkSimplify;
		wxFileDialog dlgFileOpen, dlgFileSave;
		wxString lastfile;
		wxString gnuplot_params;

		gnuplot *gp;
		GPConsole *gpc;

		struct {
			double a0;
			std::vector<double>an;
			std::vector<double>bn;
		} plotdata;

		DECLARE_EVENT_TABLE();
};

#endif // _FORIJER_H_
