#ifndef _GNUPLOT_H_
#define _GNUPLOT_H_

#include <wx/wx.h>
#include <wx/process.h>

#ifdef __WINDOWS__
#	define GNUPLOTCMD	"pgnuplot"
#else
#	define GNUPLOTCMD	"gnuplot"
#endif

class gnuplot : private wxProcess {
	public:
		gnuplot();
		~gnuplot();
		bool init();

		bool sendcmd(const wxString &cmd);
		bool haserror() const;
		wxString geterrors();
		bool hasdata() const;
		wxString getdata();

	private:
		int pid;
		bool inited;

		void OnTerminate(int pid, int status);
		static wxString readfromstream(wxInputStream *s);
};

gnuplot *OpenGnuplot();

#endif
