#ifndef _GPCONSOLE_H_
#define _GPCONSOLE_H_

#include <wx/wx.h>
#include <wx/html/htmlwin.h>
#include "gnuplot.h"

class GPConsole : public wxFrame {
	public:
		GPConsole(wxFrame *parent, gnuplot *);

		void OnTimerDataCheck(wxTimerEvent &);
		void OnTextCmdEnter(wxCommandEvent &);
		void OnBtnExec(wxCommandEvent &);
		void OnClose(wxCloseEvent &);
		void ExecCmd();
		void ScrollToBottom();
		void ExecutedCmd(const wxString &cmd);
		
	private:
		enum {
			id_TimerDataCheck = 1,
			id_BtnExec,
			id_TextCmd,
		};
		
		wxHtmlWindow *screen;
		wxTextCtrl *cmd;
		wxTimer tmrDataChk;

		gnuplot *gp;

		DECLARE_EVENT_TABLE();
};

#endif
